## mosquitto 1.4.10

=== CMakeLists.txt ===
# This is a cmake script. Process it with the CMake gui or command line utility
# to produce makefiles / Visual Studio project files on Mac OS X and Windows.
#
# To configure the build options either use the CMake gui, or run the command
# line utility including the "-i" option.

set(CMAKE_LEGACY_CYGWIN_WIN32 0)

project(mosquitto)

cmake_minimum_required(VERSION 2.8)
# Only for version 3 and up. cmake_policy(SET CMP0042 NEW)

set (VERSION 1.4.10)

if (WIN32)
	execute_process(COMMAND cmd /c echo %DATE% %TIME% OUTPUT_VARIABLE TIMESTAMP
			OUTPUT_STRIP_TRAILING_WHITESPACE)
else (WIN32)
	execute_process(COMMAND date "+%F %T%z" OUTPUT_VARIABLE TIMESTAMP
			OUTPUT_STRIP_TRAILING_WHITESPACE)
endif (WIN32)

add_definitions (-DCMAKE -DVERSION=\"${VERSION}\" -DTIMESTAMP=\"${TIMESTAMP}\")

if (WIN32)
	set (BINDIR .)
	set (SBINDIR .)
	set (SYSCONFDIR .)
	set (LIBDIR .)
	set (INCLUDEDIR include)
	set (DATAROOTDIR share)
	set (MANDIR man)
	set (SHAREDEST .)
	add_definitions("-D_CRT_SECURE_NO_WARNINGS")
	add_definitions("-D_CRT_NONSTDC_NO_DEPRECATE")
else (WIN32)
	set (BINDIR bin)
	set (SBINDIR sbin)
	if ("${CMAKE_INSTALL_PREFIX}" STREQUAL /usr)
		set (SYSCONFDIR /etc/mosquitto)
	else ("${CMAKE_INSTALL_PREFIX}" STREQUAL /usr)
		set (SYSCONFDIR etc/mosquitto)
	endif ("${CMAKE_INSTALL_PREFIX}" STREQUAL /usr)
	
	set (LIBDIR lib${LIB_SUFFIX})
	set (CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIBDIR}")
	set (INCLUDEDIR include)
	set (DATAROOTDIR share)
	set (MANDIR "${DATAROOTDIR}/man")
	set (SHAREDIR "${DATAROOTDIR}/mosquitto")
endif (WIN32)

option(WITH_TLS
	"Include SSL/TLS support?" ON)
option(WITH_TLS_PSK
	"Include TLS-PSK support (requires WITH_TLS)?" ON)
option(WITH_EC
	"Include Elliptic Curve support (requires WITH_TLS)?" ON)
if (${WITH_TLS} STREQUAL ON)
	find_package(OpenSSL REQUIRED)
	add_definitions("-DWITH_TLS")

	if (${WITH_TLS_PSK} STREQUAL ON)
		add_definitions("-DWITH_TLS_PSK")
	endif (${WITH_TLS_PSK} STREQUAL ON)

	if (${WITH_EC} STREQUAL ON)
		add_definitions("-DWITH_EC")
	endif (${WITH_EC} STREQUAL ON)
else (${WITH_TLS} STREQUAL ON)
	set (OPENSSL_INCLUDE_DIR "")
endif (${WITH_TLS} STREQUAL ON)

option(WITH_SOCKS "Include SOCKS5 support?" ON)
if (${WITH_SOCKS} STREQUAL ON)
	add_definitions("-DWITH_SOCKS")
endif (${WITH_SOCKS} STREQUAL ON)

option(WITH_SRV "Include SRV lookup support?" ON)

# ========================================
# Include projects
# ========================================

add_subdirectory(lib)
add_subdirectory(client)
add_subdirectory(src)
add_subdirectory(man)

# ========================================
# Install config file
# ========================================

install(FILES mosquitto.conf aclfile.example pskfile.example pwfile.example DESTINATION "${SYSCONFDIR}")

=== lib/CMakeLists.txt ===
add_subdirectory(cpp)

option(WITH_THREADING "Include client library threading support?" ON)
if (${WITH_THREADING} STREQUAL ON)
	add_definitions("-DWITH_THREADING")
	if (WIN32)
		set (PTHREAD_LIBRARIES C:\\pthreads\\Pre-built.2\\lib\\x86\\pthreadVC2.lib)
		set (PTHREAD_INCLUDE_DIR C:\\pthreads\\Pre-built.2\\include)
	else (WIN32)
		set (PTHREAD_LIBRARIES pthread)
		set (PTHREAD_INCLUDE_DIR "")
	endif (WIN32)
else (${WITH_THREADING} STREQUAL ON)
	set (PTHREAD_LIBRARIES "")
	set (PTHREAD_INCLUDE_DIR "")
endif (${WITH_THREADING} STREQUAL ON)

include_directories(${mosquitto_SOURCE_DIR} ${mosquitto_SOURCE_DIR}/lib
			${STDBOOL_H_PATH} ${STDINT_H_PATH}
			${OPENSSL_INCLUDE_DIR} ${PTHREAD_INCLUDE_DIR})
link_directories(${mosquitto_SOURCE_DIR}/lib)

add_library(libmosquitto SHARED
	logging_mosq.c logging_mosq.h
	memory_mosq.c memory_mosq.h
	messages_mosq.c messages_mosq.h
	mosquitto.c mosquitto.h
	mosquitto_internal.h
	mqtt3_protocol.h
	net_mosq.c net_mosq.h
	read_handle.c read_handle.h
	read_handle_client.c
	read_handle_shared.c
	send_client_mosq.c
	send_mosq.c send_mosq.h
	socks_mosq.c
	srv_mosq.c
	thread_mosq.c
	time_mosq.c
	tls_mosq.c
	util_mosq.c util_mosq.h
	will_mosq.c will_mosq.h)

set (LIBRARIES ${OPENSSL_LIBRARIES} ${PTHREAD_LIBRARIES})

if (UNIX AND NOT APPLE)
	set (LIBRARIES ${LIBRARIES} rt)
endif (UNIX AND NOT APPLE)

if (WIN32)
	set (LIBRARIES ${LIBRARIES} ws2_32)
endif (WIN32)

if (${WITH_SRV} STREQUAL ON)
	# Simple detect c-ares
	find_path(ARES_HEADER ares.h)
	if (ARES_HEADER)
		add_definitions("-DWITH_SRV")
		set (LIBRARIES ${LIBRARIES} cares)
	else (ARES_HEADER)
		message(WARNING "c-ares library not found.")
	endif (ARES_HEADER)
endif (${WITH_SRV} STREQUAL ON)

target_link_libraries(libmosquitto ${LIBRARIES})

set_target_properties(libmosquitto PROPERTIES
	OUTPUT_NAME mosquitto
	VERSION ${VERSION}
	SOVERSION 1
)

install(TARGETS libmosquitto RUNTIME DESTINATION "${BINDIR}" LIBRARY DESTINATION "${LIBDIR}")
install(FILES mosquitto.h DESTINATION "${INCLUDEDIR}")

if (UNIX)
	install(CODE "EXEC_PROGRAM(/sbin/ldconfig)")
endif (UNIX)

=== src/CMakeLists.txt ===
include_directories(${mosquitto_SOURCE_DIR} ${mosquitto_SOURCE_DIR}/src
		${mosquitto_SOURCE_DIR}/lib ${OPENSSL_INCLUDE_DIR}
		${STDBOOL_H_PATH} ${STDINT_H_PATH})

set (MOSQ_SRCS
	conf.c
	context.c
	database.c
	lib_load.h
	logging.c
	loop.c
	../lib/memory_mosq.c ../lib/memory_mosq.h
	mosquitto.c
	mosquitto_broker.h
	net.c
	../lib/net_mosq.c ../lib/net_mosq.h
	persist.c persist.h
	read_handle.c read_handle_client.c read_handle_server.c
	../lib/read_handle_shared.c ../lib/read_handle.h
	subs.c
	security.c security_default.c
	../lib/send_client_mosq.c ../lib/send_mosq.h
	../lib/send_mosq.c ../lib/send_mosq.h
	send_server.c
	sys_tree.c
	../lib/time_mosq.c
	../lib/tls_mosq.c
	../lib/util_mosq.c ../lib/util_mosq.h
	websockets.c
	../lib/will_mosq.c ../lib/will_mosq.h)

option(INC_BRIDGE_SUPPORT
	"Include bridge support for connecting to other brokers?" ON)
if (${INC_BRIDGE_SUPPORT} STREQUAL ON)
	set (MOSQ_SRCS ${MOSQ_SRCS} bridge.c)
	add_definitions("-DWITH_BRIDGE")
endif (${INC_BRIDGE_SUPPORT} STREQUAL ON)


option(USE_LIBWRAP
	"Include tcp-wrappers support?" OFF)

if (${USE_LIBWRAP} STREQUAL ON)
	set (MOSQ_LIBS ${MOSQ_LIBS} wrap)
	add_definitions("-DWITH_WRAP")
endif (${USE_LIBWRAP} STREQUAL ON)

option(INC_DB_UPGRADE
	"Include database upgrade support? (recommended)" ON)

option(INC_MEMTRACK
	"Include memory tracking support?" ON)
if (${INC_MEMTRACK} STREQUAL ON)
	add_definitions("-DWITH_MEMORY_TRACKING")
endif (${INC_MEMTRACK} STREQUAL ON)

option(WITH_PERSISTENCE
	"Include persistence support?" ON)
if (${WITH_PERSISTENCE} STREQUAL ON)
	add_definitions("-DWITH_PERSISTENCE")
endif (${WITH_PERSISTENCE} STREQUAL ON)

option(WITH_SYS_TREE
	"Include $SYS tree support?" ON)
if (${WITH_SYS_TREE} STREQUAL ON)
	add_definitions("-DWITH_SYS_TREE")
endif (${WITH_SYS_TREE} STREQUAL ON)

option(WITH_WEBSOCKETS
	"Include websockets support?" OFF)
if (${WITH_WEBSOCKETS} STREQUAL ON)
	add_definitions("-DWITH_WEBSOCKETS")
endif (${WITH_WEBSOCKETS} STREQUAL ON)

if (WIN32 OR CYGWIN)
	set (MOSQ_SRCS ${MOSQ_SRCS} service.c)
endif (WIN32 OR CYGWIN)

add_definitions (-DWITH_BROKER)

add_executable(mosquitto ${MOSQ_SRCS})

set (MOSQ_LIBS ${MOSQ_LIBS} ${OPENSSL_LIBRARIES})

if (UNIX)
	if (APPLE)
		set (MOSQ_LIBS ${MOSQ_LIBS} dl m)
	else (APPLE)
		set (MOSQ_LIBS ${MOSQ_LIBS} rt dl m)
	endif (APPLE)
endif (UNIX)

if (WIN32)
	set (MOSQ_LIBS ${MOSQ_LIBS} ws2_32)
endif (WIN32)

if (${WITH_WEBSOCKETS} STREQUAL ON)
	set (MOSQ_LIBS ${MOSQ_LIBS} websockets)
endif (${WITH_WEBSOCKETS} STREQUAL ON)

# Simple detect libuuid
if(NOT APPLE)
	FIND_PATH(UUID_HEADER uuid/uuid.h)
	if (UUID_HEADER)
		add_definitions(-DWITH_UUID)
		set (MOSQ_LIBS ${MOSQ_LIBS} uuid)
	endif (UUID_HEADER)
endif(NOT APPLE)

target_link_libraries(mosquitto ${MOSQ_LIBS})

if (UNIX)
	if (APPLE)
		set_target_properties(mosquitto PROPERTIES LINK_FLAGS "-Wl,-exported_symbols_list -Wl,${mosquitto_SOURCE_DIR}/src/linker-macosx.syms")
	else (APPLE)
		set_target_properties(mosquitto PROPERTIES LINK_FLAGS "-Wl,-dynamic-list=${mosquitto_SOURCE_DIR}/src/linker.syms")
	endif (APPLE)
endif (UNIX)

install(TARGETS mosquitto RUNTIME DESTINATION "${SBINDIR}" LIBRARY DESTINATION "${LIBDIR}")
install(FILES mosquitto_plugin.h DESTINATION "${INCLUDEDIR}")

if (${WITH_TLS} STREQUAL ON)
	add_executable(mosquitto_passwd mosquitto_passwd.c)
	target_link_libraries(mosquitto_passwd "${OPENSSL_LIBRARIES}")
	install(TARGETS mosquitto_passwd RUNTIME DESTINATION "${BINDIR}" LIBRARY DESTINATION "${LIBDIR}")
endif (${WITH_TLS} STREQUAL ON)

if (UNIX)
	install(CODE "EXEC_PROGRAM(/sbin/ldconfig)")
endif (UNIX)

=== test/broker/Makefile ===
include ../../config.mk

.PHONY: all clean test
.NOTPARALLEL:

all :

clean : 
	-rm -f *.vglog
	$(MAKE) -C c clean

test-compile : 
	$(MAKE) -C c

test : test-compile 01 02 03 04 05 06 07 08 09 10

01 :
	./01-connect-success.py
	./01-connect-invalid-protonum.py
	./01-connect-invalid-id-0.py
	./01-connect-invalid-id-0-311.py
	./01-connect-invalid-id-missing.py
	./01-connect-anon-denied.py
	./01-connect-uname-no-password-denied.py
	./01-connect-uname-password-denied.py
ifeq ($(WITH_TLS),yes)
	./01-connect-uname-password-success.py
else
	./01-connect-uname-password-success-no-tls.py
endif


02 :
	./02-subscribe-qos0.py
	./02-subscribe-qos1.py
	./02-subscribe-qos2.py
	./02-subpub-qos0.py
	./02-subpub-qos1.py
	./02-subpub-qos2.py
	./02-unsubscribe-qos0.py
	./02-unsubscribe-qos1.py
	./02-unsubscribe-qos2.py

03 :
	./03-publish-qos1.py
	./03-publish-qos2.py
	./03-publish-b2c-timeout-qos1.py
	./03-publish-b2c-disconnect-qos1.py
	./03-publish-c2b-timeout-qos2.py
	./03-publish-c2b-disconnect-qos2.py
	./03-publish-b2c-timeout-qos2.py
	./03-publish-b2c-disconnect-qos2.py
	./03-pattern-matching.py

04 :
	./04-retain-qos0.py
	./04-retain-qos0-fresh.py
	./04-retain-qos0-repeated.py
	./04-retain-qos1-qos0.py
	./04-retain-qos0-clear.py

05 :
	./05-clean-session-qos1.py 

06 :
	./06-bridge-reconnect-local-out.py
	./06-bridge-br2b-disconnect-qos1.py
	./06-bridge-br2b-disconnect-qos2.py
	./06-bridge-b2br-disconnect-qos1.py
	./06-bridge-b2br-disconnect-qos2.py
	./06-bridge-fail-persist-resend-qos1.py
	./06-bridge-fail-persist-resend-qos2.py

07 :
	./07-will-qos0.py
	./07-will-null.py
	./07-will-null-topic.py

08 :
ifeq ($(WITH_TLS),yes)
	./08-ssl-connect-no-auth.py
	./08-ssl-connect-no-auth-wrong-ca.py
	./08-ssl-connect-cert-auth.py
	./08-ssl-connect-cert-auth-without.py
	./08-ssl-connect-cert-auth-expired.py
	./08-ssl-connect-cert-auth-revoked.py
	./08-ssl-connect-cert-auth-crl.py
	./08-ssl-connect-identity.py
	./08-ssl-connect-no-identity.py
	./08-ssl-bridge.py
	./08-tls-psk-pub.py
	./08-tls-psk-bridge.py
endif

09 :
	./09-plugin-auth-unpwd-success.py
	./09-plugin-auth-unpwd-fail.py

10 :
	./10-listener-mount-point.py

=== debian/changelog ===
mosquitto (1.4.10-3+deb9u5) stretch-security; urgency=medium

  * Non-maintainer upload by the LTS Security Team.
  * Don't derefence a null message. CVE-2017-7655

 -- Anton Gladky <gladk@debian.org>  Tue, 26 Oct 2021 22:24:15 +0200

mosquitto (1.4.10-3+deb9u4) stretch-security; urgency=high

  * Fix potential crash when reloading persistence file. (closes: #922071).

 -- Roger A. Light <roger@atchoo.org>  Wed, 13 Feb 2019 00:45:38 +0000

mosquitto (1.4.10-3+deb9u3) stretch-security; urgency=high

  * SECURITY UPDATE: If Mosquitto is configured to use a password file for
    authentication, any malformed data in the password file will be treated as
    valid. This typically means that the malformed data becomes a username and
    no password. If this occurs, clients can circumvent authentication and get
    access to the broker by using the malformed username. In particular, a blank
    line will be treated as a valid empty username. Other security measures are
    unaffected. Users who have only used the mosquitto_passwd utility to create
    and modify their password files are unaffected by this vulnerability.
    - debian/patches/mosquitto-1.4.x-cve-2018-12551.patch: this fix introduces
      more stringent parsing tests on the password file data.
    - CVE-2018-12551
  * SECURITY UPDATE: If an ACL file is empty, or has only blank lines or
    comments, then mosquitto treats the ACL file as not being defined, which
    means that no topic access is denied. Although denying access to all
    topics is not a useful configuration, this behaviour is unexpected and
    could lead to access being incorrectly granted in some circumstances.
    - debian/patches/mosquitto-1.4.x-cve-2018-12550.patch: this fix ensures
      that if an ACL file is defined but no rules are defined, then access will
      be denied.
    - CVE-2018-12550
  * SECURITY UPDATE: If a client publishes a retained message to a topic that
    they have access to, and then their access to that topic is revoked, the
    retained message will still be delivered to future subscribers. This
    behaviour may be undesirable in some applications, so a configuration
    option `check_retain_source` has been introduced to enforce checking of
    the retained message source on publish.
    - debian/patches/mosquitto-1.4.9-1.4.14-cve-2018-12546.patch: this patch stores
      the originator of the retained message, so security checking can be
      carried out before re-publishing. The complexity of the patch is due to
      the need to save this information across broker restarts.
    - CVE-2018-12546

 -- Roger A. Light <roger@atchoo.org>  Wed, 06 Feb 2019 17:03:31 +0000

mosquitto (1.4.10-3+deb9u2) stretch-security; urgency=medium

  * Non-maintainer upload by the LTS Team.
  * fix for CVE-2017-7654
  * fix for CVE-2017-7653
  * fix for CVE-2017-7652
  * fix for CVE-2017-7651

 -- Thorsten Alteholz <debian@alteholz.de>  Wed, 17 Oct 2018 19:03:03 +0200

mosquitto (1.4.10-3+deb9u1) stretch; urgency=medium

  * SECURITY UPDATE: Mosquitto persistence file is world readable.
    - debian/patches/mosquitto-1.4.x_cve-2017-9868.patch: Set umask to limit
      read permissions.
    - CVE-2017-9868

 -- Roger A. Light <roger@atchoo.org>  Fri, 22 Dec 2017 08:19:25 +0000

mosquitto (1.4.10-3) unstable; urgency=high

  * SECURITY UPDATE: Pattern ACL can be bypassed by using a username/client id
    set to '+' or '#'.
    - debian/patches/mosquitto-0.15_cve-2017-7650.patch: Reject send/receive
      of messages to/from clients with a '+', '#' or '/' in their
      username/client id.
    - CVE-2017-7650
  * New patch debian/patches/allow_ipv6_bridges.patch allows bridges to make
    IPv6 connections when using TLS (closes: #857759).

 -- Roger A. Light <roger@atchoo.org>  Mon, 29 May 2017 13:43:29 +0100

mosquitto (1.4.10-2) unstable; urgency=medium

  * Bumped standards version to 3.9.8. No changes needed.
  * Bumped dh compat level to 10.
  * Vcs-* links updated.

 -- Roger A. Light <roger@atchoo.org>  Thu, 03 Nov 2016 22:37:33 +0000

mosquitto (1.4.10-1) unstable; urgency=low

  * New upstream release.
  * Add support for openssl 1.1.0 (closes: #828442)
  * Fix FTBFS on Hurd (closes: #824571)

 -- Roger A. Light <roger@atchoo.org>  Thu, 27 Oct 2016 14:01:40 +0100

=== debian/control ===
Source: mosquitto
Section: net
Priority: optional
Maintainer: Roger A. Light <roger@atchoo.org>
Build-Depends: debhelper (>= 10),
               libc-ares-dev,
               libssl-dev (>=1.0.0),
               libwebsockets-dev (>=1.2),
               libwrap0-dev,
               python-all (>= 2.6.6-3~),
               uthash-dev,
               uuid-dev
Standards-Version: 3.9.8
Homepage: http://mosquitto.org/
Vcs-Git: https://github.com/eclipse/mosquitto
Vcs-Browser: https://github.com/eclipse/mosquitto/tree/debian

Package: mosquitto
Architecture: any
Multi-Arch: foreign
Depends: adduser (>= 3.10),
         libuuid1,
         lsb-base (>=4.1+Debian3),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: apparmor
Description: MQTT version 3.1/3.1.1 compatible message broker
 This is a message broker that supports version 3.1 and 3.1.1 of the MQTT
 protocol.
 .
 MQTT provides a method of carrying out messaging using a publish/subscribe
 model. It is lightweight, both in terms of bandwidth usage and ease of
 implementation. This makes it particularly useful at the edge of the network
 where a sensor or other simple device may be implemented using an arduino for
 example.

Package: mosquitto-dev
Section: devel
Architecture: all
Multi-Arch: foreign
Depends: mosquitto (<< ${source:Version}.1~),
         mosquitto (>= ${source:Version}),
         ${misc:Depends}
Description: Development files for Mosquitto
 Mosquitto is a message broker that supports the MQTT protocol.
 .
 This package contains the include files used if you wish to compile a package
 which requires Mosquitto's source file headers.

Package: libmosquitto1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: MQTT version 3.1/3.1.1 client library
 This is a C library for implementing MQTT version 3.1/3.1.1 clients.
 .
 MQTT provides a method of carrying out messaging using a publish/subscribe
 model. It is lightweight, both in terms of bandwidth usage and ease of
 implementation. This makes it particularly useful at the edge of the network
 where a sensor or other simple device may be implemented using an arduino for
 example.

Package: libmosquitto-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmosquitto1 (<< ${source:Version}.1~),
         libmosquitto1 (>= ${source:Version}),
         ${misc:Depends}
Replaces: libmosquitto0-dev (<< 1.2-1~)
Breaks: libmosquitto0-dev (<< 1.2-1~)
Description: MQTT version 3.1/3.1.1 client library, development files
 This is the header and man page for the libmosquitto1 C library, which is a
 library for implementing MQTT version 3.1/3.1.1 clients. This package is needed to do
 development with libmosquitto1.

Package: libmosquittopp1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libmosquitto1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: MQTT version 3.1/3.1.1 client C++ library
 This is a C++ library for implementing MQTT version 3.1/3.1.1 clients.
 .
 MQTT provides a method of carrying out messaging using a publish/subscribe
 model. It is lightweight, both in terms of bandwidth usage and ease of
 implementation. This makes it particularly useful at the edge of the network
 where a sensor or other simple device may be implemented using an arduino for
 example.

Package: libmosquittopp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmosquittopp1 (<< ${source:Version}.1~),
         libmosquittopp1 (>= ${source:Version}),
         libmosquitto-dev,
         ${misc:Depends}
Replaces: libmosquittopp0-dev (<< 1.2-1~)
Breaks: libmosquittopp0-dev (<< 1.2-1~)
Description: MQTT version 3.1 client C++ library, development files
 This is the header and man page for the libmosquittopp1 C++ library, which is
 a library for implementing MQTT version 3.1 clients. This package is needed to
 do development with libmosquittopp1.

Package: mosquitto-clients
Architecture: any
Multi-Arch: foreign
Depends: libmosquitto1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Mosquitto command line MQTT clients
 This is two MQTT version 3.1/3.1.1 command line clients. mosquitto_pub can be
 used to publish messages to a broker and mosquitto_sub can be used to
 subscribe to a topic to receive messages.
 .
 MQTT provides a method of carrying out messaging using a publish/subscribe
 model. It is lightweight, both in terms of bandwidth usage and ease of
 implementation. This makes it particularly useful at the edge of the network
 where a sensor or other simple device may be implemented using an arduino for
 example.

Package: mosquitto-dbg
Architecture: any
Multi-Arch: foreign
Priority: extra
Section: debug
Depends: mosquitto (= ${binary:Version}) | mosquitto-clients (= ${binary:Version}),
         ${misc:Depends}
Description: debugging symbols for mosquitto binaries
 This package contains debugging files used to investigate problems with
 the binaries provided by the packages mosquitto, mosquitto-clients,
 libmosquitto1 and libmosquittopp1.

Package: libmosquitto1-dbg
Architecture: any
Multi-Arch: same
Priority: extra
Section: debug
Depends: libmosquitto1 (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for libmosquitto binaries
 This package contains debugging files used to investigate problems with
 the binaries provided by the libmosquitto1 package.

Package: libmosquittopp1-dbg
Architecture: any
Multi-Arch: same
Priority: extra
Section: debug
Depends: libmosquittopp1 (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for libmosquittopp binaries
 This package contains debugging files used to investigate problems with
 the binaries provided by the libmosquittopp1 package.

## mosquitto 1.4.12

=== debian/changelog ===
mosquitto (1.4.12-1ubuntu0.1) artful-security; urgency=medium

  * Add upstream patch for CVE 2017-7651 (LP: #1752591)

 -- Emmet Hikory <persia@ubuntu.com>  Thu, 01 Mar 2018 09:24:46 -0500

mosquitto (1.4.12-1) experimental; urgency=low

  * New upstream release.

 -- Roger A. Light <roger@atchoo.org>  Mon, 29 May 2017 14:56:32 +0100

## mosquitto 1.4.14

=== debian/changelog ===
mosquitto (1.4.14-1) unstable; urgency=medium

  * SECURITY UPDATE: Persistence file is world readable, which may expose
    sensitive data. Fixed by upstream release 1.4.13.
    - CVE-2017-9868
  * New upstream release.
  * Remove upstart support.
  * Bumped standards version to 4.1.2.
    - Removed invoke-rc.d conditionals.
    - Changed "extra" priorities to "optional".
  * Build-Depends: Add dh-systemd, bump libwebsockets to >=2.0.
  * no-man-clean.patch - don't clean man pages from source directory.
  * async_dns.patch - enable bridge async DNS lookups.

 -- Roger A. Light <roger@atchoo.org>  Fri, 22 Dec 2017 07:14:19 +0000

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,15 @@
 Priority: optional
 Maintainer: Roger A. Light <roger@atchoo.org>
 Build-Depends: debhelper (>= 10),
+               dh-systemd,
                libc-ares-dev,
                libssl-dev (>=1.0.0),
-               libwebsockets-dev (>=1.2),
+               libwebsockets-dev (>=2.0),
                libwrap0-dev,
                python-all (>= 2.6.6-3~),
                uthash-dev,
                uuid-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.1.2
 Homepage: http://mosquitto.org/
 Vcs-Git: https://github.com/eclipse/mosquitto
 Vcs-Browser: https://github.com/eclipse/mosquitto/tree/debian
@@ -127,7 +128,7 @@
 Package: mosquitto-dbg
 Architecture: any
 Multi-Arch: foreign
-Priority: extra
+Priority: optional
 Section: debug
 Depends: mosquitto (= ${binary:Version}) | mosquitto-clients (= ${binary:Version}),
          ${misc:Depends}
@@ -139,7 +140,7 @@
 Package: libmosquitto1-dbg
 Architecture: any
 Multi-Arch: same
-Priority: extra
+Priority: optional
 Section: debug
 Depends: libmosquitto1 (= ${binary:Version}), ${misc:Depends}
 Description: debugging symbols for libmosquitto binaries
@@ -149,7 +150,7 @@
 Package: libmosquittopp1-dbg
 Architecture: any
 Multi-Arch: same
-Priority: extra
+Priority: optional
 Section: debug
 Depends: libmosquittopp1 (= ${binary:Version}), ${misc:Depends}
 Description: debugging symbols for libmosquittopp binaries

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --with systemd

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog.txt

override_dh_auto_configure:
	# Don't process CMake rules, CMakeLists.txt is only included for Windows/Mac support.

override_dh_auto_test:

override_dh_strip:
	dh_strip --dbg-package=mosquitto-dbg -Xlibmosquitto
	dh_strip --dbg-package=libmosquitto1-dbg -Xlibmosquittopp -Xsbin/mosquitto
	dh_strip --dbg-package=libmosquittopp1-dbg -Xlibmosquitto.so -Xsbin/mosquitto

override_dh_auto_install:
	dh_auto_install
	install -d debian/tmp/etc/mosquitto/conf.d/
	install -m 644 debian/README-conf-d debian/tmp/etc/mosquitto/conf.d/README
	install -d debian/tmp/etc/mosquitto/ca_certificates/
	install -m 644 debian/README-ca_certificates debian/tmp/etc/mosquitto/ca_certificates/README
	install -d debian/tmp/etc/mosquitto/certs/
	install -m 644 debian/README-certs debian/tmp/etc/mosquitto/certs/README
	install -m 644 debian/mosquitto.conf debian/tmp/etc/mosquitto/mosquitto.conf

## mosquitto 1.4.15

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 cmake_minimum_required(VERSION 2.8)
 # Only for version 3 and up. cmake_policy(SET CMP0042 NEW)
 
-set (VERSION 1.4.10)
+set (VERSION 1.4.15)
 
 if (WIN32)
 	execute_process(COMMAND cmd /c echo %DATE% %TIME% OUTPUT_VARIABLE TIMESTAMP

=== Makefile ===
include config.mk

DIRS=lib client src
DOCDIRS=man
DISTDIRS=man

.PHONY : all mosquitto docs binary clean reallyclean test install uninstall dist sign copy

all : $(MAKE_ALL)

docs :
	set -e; for d in ${DOCDIRS}; do $(MAKE) -C $${d}; done

binary : mosquitto

mosquitto :
ifeq ($(UNAME),Darwin)
	$(error Please compile using CMake on Mac OS X)
endif

	set -e; for d in ${DIRS}; do $(MAKE) -C $${d}; done

clean :
	set -e; for d in ${DIRS}; do $(MAKE) -C $${d} clean; done
	set -e; for d in ${DOCDIRS}; do $(MAKE) -C $${d} clean; done
	$(MAKE) -C test clean

reallyclean : 
	set -e; for d in ${DIRS}; do $(MAKE) -C $${d} reallyclean; done
	set -e; for d in ${DOCDIRS}; do $(MAKE) -C $${d} reallyclean; done
	$(MAKE) -C test reallyclean
	-rm -f *.orig

test : mosquitto
	$(MAKE) -C test test

install : mosquitto
	set -e; for d in ${DIRS}; do $(MAKE) -C $${d} install; done
ifeq ($(WITH_DOCS),yes)
	set -e; for d in ${DOCDIRS}; do $(MAKE) -C $${d} install; done
endif
	$(INSTALL) -d ${DESTDIR}/etc/mosquitto
	$(INSTALL) -m 644 mosquitto.conf ${DESTDIR}/etc/mosquitto/mosquitto.conf.example
	$(INSTALL) -m 644 aclfile.example ${DESTDIR}/etc/mosquitto/aclfile.example
	$(INSTALL) -m 644 pwfile.example ${DESTDIR}/etc/mosquitto/pwfile.example
	$(INSTALL) -m 644 pskfile.example ${DESTDIR}/etc/mosquitto/pskfile.example

uninstall :
	set -e; for d in ${DIRS}; do $(MAKE) -C $${d} uninstall; done
	rm -f ${DESTDIR}/etc/mosquitto/mosquitto.conf
	rm -f ${DESTDIR}/etc/mosquitto/aclfile.example
	rm -f ${DESTDIR}/etc/mosquitto/pwfile.example
	rm -f ${DESTDIR}/etc/mosquitto/pskfile.example

dist : reallyclean
	set -e; for d in ${DISTDIRS}; do $(MAKE) -C $${d} dist; done
	
	mkdir -p dist/mosquitto-${VERSION}
	cp -r client examples installer lib logo man misc security service src test about.html aclfile.example ChangeLog.txt CMakeLists.txt compiling.txt config.h config.mk CONTRIBUTING.md edl-v10 epl-v10 LICENSE.txt Makefile mosquitto.conf notice.html pskfile.example pwfile.example readme.md readme-windows.txt dist/mosquitto-${VERSION}/
	cd dist; tar -zcf mosquitto-${VERSION}.tar.gz mosquitto-${VERSION}/
	set -e; for m in man/*.xml; \
		do \
		hfile=$$(echo $${m} | sed -e 's#man/\(.*\)\.xml#\1#' | sed -e 's/\./-/g'); \
		$(XSLTPROC) $(DB_HTML_XSL) $${m} > dist/$${hfile}.html; \
	done


sign : dist
	cd dist; gpg --detach-sign -a mosquitto-${VERSION}.tar.gz

copy : sign
	cd dist; scp mosquitto-${VERSION}.tar.gz mosquitto-${VERSION}.tar.gz.asc mosquitto:site/mosquitto.org/files/source/
	cd dist; scp *.html mosquitto:site/mosquitto.org/man/
	scp ChangeLog.txt mosquitto:site/mosquitto.org/

=== client/CMakeLists.txt ===
include_directories(${mosquitto_SOURCE_DIR}/lib
			${STDBOOL_H_PATH} ${STDINT_H_PATH})
link_directories(${mosquitto_BINARY_DIR}/lib)

set(shared_src client_shared.c client_shared.h)

if (${WITH_SRV} STREQUAL ON)
	add_definitions("-DWITH_SRV")
endif (${WITH_SRV} STREQUAL ON)

add_executable(mosquitto_pub pub_client.c ${shared_src})
add_executable(mosquitto_sub sub_client.c ${shared_src})

target_link_libraries(mosquitto_pub libmosquitto)
target_link_libraries(mosquitto_sub libmosquitto)

install(TARGETS mosquitto_pub RUNTIME DESTINATION "${BINDIR}" LIBRARY DESTINATION "${LIBDIR}")
install(TARGETS mosquitto_sub RUNTIME DESTINATION "${BINDIR}" LIBRARY DESTINATION "${LIBDIR}")

=== man/CMakeLists.txt ===
install(FILES mosquitto_passwd.1 mosquitto_pub.1 mosquitto_sub.1 DESTINATION ${MANDIR}/man1)
install(FILES libmosquitto.3 DESTINATION ${MANDIR}/man3)
install(FILES mosquitto.conf.5 DESTINATION ${MANDIR}/man5)
install(FILES mosquitto-tls.7 mqtt.7 DESTINATION ${MANDIR}/man7)
install(FILES mosquitto.8 DESTINATION ${MANDIR}/man8)

=== man/Makefile ===
include ../config.mk

.PHONY : all clean install uninstall dist 

all :  mosquitto.8 mosquitto-tls.7 mosquitto.conf.5 mosquitto_passwd.1 mosquitto_pub.1 mosquitto_sub.1 mqtt.7 libmosquitto.3

clean :

reallyclean : clean
	-rm -f *.orig
	-rm -f libmosquitto.3
	-rm -f mosquitto.8
	-rm -f mosquitto.conf.5
	-rm -f mosquitto_passwd.1
	-rm -f mosquitto_pub.1
	-rm -f mosquitto_sub.1
	-rm -f mosquitto-tls.7
	-rm -f mqtt.7

dist : mosquitto.8 mosquitto-tls.7 mosquitto.conf.5 mosquitto_passwd.1 mosquitto_pub.1 mosquitto_sub.1 mqtt.7 libmosquitto.3

install :
	$(INSTALL) -d ${DESTDIR}$(mandir)/man8
	$(INSTALL) -m 644 mosquitto.8 ${DESTDIR}${mandir}/man8/mosquitto.8
	$(INSTALL) -d ${DESTDIR}$(mandir)/man5
	$(INSTALL) -m 644 mosquitto.conf.5 ${DESTDIR}${mandir}/man5/mosquitto.conf.5
	$(INSTALL) -d ${DESTDIR}$(mandir)/man1
	$(INSTALL) -m 644 mosquitto_passwd.1 ${DESTDIR}${mandir}/man1/mosquitto_passwd.1
	$(INSTALL) -m 644 mosquitto_pub.1 ${DESTDIR}${mandir}/man1/mosquitto_pub.1
	$(INSTALL) -m 644 mosquitto_sub.1 ${DESTDIR}${mandir}/man1/mosquitto_sub.1
	$(INSTALL) -d ${DESTDIR}$(mandir)/man7
	$(INSTALL) -m 644 mqtt.7 ${DESTDIR}${mandir}/man7/mqtt.7
	$(INSTALL) -m 644 mosquitto-tls.7 ${DESTDIR}${mandir}/man7/mosquitto-tls.7
	$(INSTALL) -d ${DESTDIR}$(mandir)/man3
	$(INSTALL) -m 644 libmosquitto.3 ${DESTDIR}${mandir}/man3/libmosquitto.3

uninstall :
	-rm -f ${DESTDIR}${mandir}/man8/mosquitto.8
	-rm -f ${DESTDIR}${mandir}/man5/mosquitto.conf.5
	-rm -f ${DESTDIR}${mandir}/man1/mosquitto_passwd.1
	-rm -f ${DESTDIR}${mandir}/man1/mosquitto_pub.1
	-rm -f ${DESTDIR}${mandir}/man1/mosquitto_sub.1
	-rm -f ${DESTDIR}${mandir}/man7/mqtt.7
	-rm -f ${DESTDIR}${mandir}/man7/mosquitto-tls.7
	-rm -f ${DESTDIR}${mandir}/man3/libmosquitto.3

mosquitto.8 : mosquitto.8.xml
	$(XSLTPROC) $^

mosquitto.conf.5 : mosquitto.conf.5.xml manpage.xsl
	$(XSLTPROC) $<

mosquitto_passwd.1 : mosquitto_passwd.1.xml
	$(XSLTPROC) $^

mosquitto_pub.1 : mosquitto_pub.1.xml
	$(XSLTPROC) $^

mosquitto_sub.1 : mosquitto_sub.1.xml
	$(XSLTPROC) $^

mqtt.7 : mqtt.7.xml
	$(XSLTPROC) $^

mosquitto-tls.7 : mosquitto-tls.7.xml
	$(XSLTPROC) $^

libmosquitto.3 : libmosquitto.3.xml
	$(XSLTPROC) $^

html : *.xml
	set -e; for m in *.xml; \
		do \
		hfile=$$(echo $${m} | sed -e 's#\(.*\)\.xml#\1#' | sed -e 's/\./-/g'); \
		$(XSLTPROC) html.xsl $${m} > $${hfile}.html; \
	done

potgen :
	 xml2po -o po/mosquitto/mosquitto.8.pot mosquitto.8.xml
	 xml2po -o po/mosquitto.conf/mosquitto.conf.5.pot mosquitto.conf.5.xml
	 xml2po -o po/mosquitto_passwd/mosquitto_passwd.1.pot mosquitto_passwd.1.xml
	 xml2po -o po/mosquitto_pub/mosquitto_pub.1.pot mosquitto_pub.1.xml
	 xml2po -o po/mosquitto_sub/mosquitto_sub.1.pot mosquitto_sub.1.xml
	 xml2po -o po/mqtt/mqtt.7.pot mqtt.7.xml
	 xml2po -o po/mosquitto-tls/mosquitto-tls.7.pot mosquitto-tls.7.xml
	 xml2po -o po/libmosquitto/libmosquitto.3.pot libmosquitto.3.xml

# To merge new translations do:
# /usr/bin/xml2po -p de.po chapter1.xml > chapter1.de.xml

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -82,11 +82,25 @@
 
 set (MOSQ_LIBS ${MOSQ_LIBS} ${OPENSSL_LIBRARIES})
 
+# Check for getaddrinfo_a
+include(CheckLibraryExists)
+check_library_exists(anl getaddrinfo_a  "" HAVE_GETADDRINFO_A)
+if (HAVE_GETADDRINFO_A)
+	add_definitions(-DHAVE_GETADDRINFO_A)
+	set (MOSQ_LIBS ${MOSQ_LIBS} anl)
+endif (HAVE_GETADDRINFO_A)
+
+
+
 if (UNIX)
 	if (APPLE)
 		set (MOSQ_LIBS ${MOSQ_LIBS} dl m)
 	else (APPLE)
-		set (MOSQ_LIBS ${MOSQ_LIBS} rt dl m)
+		set (MOSQ_LIBS ${MOSQ_LIBS} dl m)
+		find_library(LIBRT rt)
+		if (LIBRT)
+			set (MOSQ_LIBS ${MOSQ_LIBS} rt)
+		endif (LIBRT)
 	endif (APPLE)
 endif (UNIX)

=== src/Makefile ===
include ../config.mk

.PHONY: all install uninstall clean reallyclean

ifeq ($(WITH_TLS),yes)
all : mosquitto mosquitto_passwd
else
all : mosquitto
endif

mosquitto : mosquitto.o bridge.o conf.o context.o database.o logging.o loop.o memory_mosq.o persist.o net.o net_mosq.o read_handle.o read_handle_client.o read_handle_server.o read_handle_shared.o security.o security_default.o send_client_mosq.o send_mosq.o send_server.o service.o subs.o sys_tree.o time_mosq.o tls_mosq.o util_mosq.o websockets.o will_mosq.o
	${CROSS_COMPILE}${CC} $^ -o $@ ${LDFLAGS} $(BROKER_LIBS)

mosquitto.o : mosquitto.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

bridge.o : bridge.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@
	
conf.o : conf.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@
	
context.o : context.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

database.o : database.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

logging.o : logging.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

loop.o : loop.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

memory_mosq.o : ../lib/memory_mosq.c ../lib/memory_mosq.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

net.o : net.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

net_mosq.o : ../lib/net_mosq.c ../lib/net_mosq.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@
	
persist.o : persist.c persist.h mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@
	
read_handle.o : read_handle.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

read_handle_client.o : read_handle_client.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

read_handle_server.o : read_handle_server.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

read_handle_shared.o : ../lib/read_handle_shared.c ../lib/read_handle.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

security.o : security.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

security_default.o : security_default.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

send_client_mosq.o : ../lib/send_client_mosq.c ../lib/send_mosq.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

send_mosq.o : ../lib/send_mosq.c ../lib/send_mosq.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

send_server.o : send_server.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

service.o : service.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

subs.o : subs.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

sys_tree.o : sys_tree.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

time_mosq.o : ../lib/time_mosq.c ../lib/time_mosq.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

tls_mosq.o : ../lib/tls_mosq.c
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

util_mosq.o : ../lib/util_mosq.c ../lib/util_mosq.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

websockets.o : websockets.c mosquitto_broker.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

will_mosq.o : ../lib/will_mosq.c ../lib/will_mosq.h
	${CROSS_COMPILE}${CC} $(BROKER_CFLAGS) -c $< -o $@

mosquitto_passwd : mosquitto_passwd.o
	${CROSS_COMPILE}${CC} $^ -o $@ ${LDFLAGS} $(PASSWD_LIBS)

mosquitto_passwd.o : mosquitto_passwd.c
	${CROSS_COMPILE}${CC} $(CFLAGS) ${CPPFLAGS} -c $< -o $@

install : all
	$(INSTALL) -d ${DESTDIR}$(prefix)/sbin
	$(INSTALL) -s --strip-program=${CROSS_COMPILE}${STRIP} mosquitto ${DESTDIR}${prefix}/sbin/mosquitto
	$(INSTALL) -d ${DESTDIR}$(prefix)/include
	$(INSTALL) mosquitto_plugin.h ${DESTDIR}${prefix}/include/mosquitto_plugin.h
ifeq ($(WITH_TLS),yes)
	$(INSTALL) -d ${DESTDIR}$(prefix)/bin
	$(INSTALL) -s --strip-program=${CROSS_COMPILE}${STRIP} mosquitto_passwd ${DESTDIR}${prefix}/bin/mosquitto_passwd
endif

uninstall :
	-rm -f ${DESTDIR}${prefix}/sbin/mosquitto
	-rm -f ${DESTDIR}${prefix}/include/mosquitto_plugin.h
	-rm -f ${DESTDIR}${prefix}/bin/mosquitto_passwd

clean : 
	-rm -f *.o mosquitto mosquitto_passwd

reallyclean : clean
	-rm -rf *.orig *.db

=== src/db_dump/Makefile ===
include ../../config.mk

CFLAGS_FINAL=${CFLAGS} -I.. -I../../lib -I../..

.PHONY: all clean reallyclean

all : mosquitto_db_dump

mosquitto_db_dump : db_dump.o
	${CROSS_COMPILE}${CC} $^ -o $@ ${LDFLAGS} ${LIBS}

db_dump.o : db_dump.c ../persist.h
	${CROSS_COMPILE}${CC} $(CFLAGS_FINAL) -c $< -o $@

clean : 
	-rm -f *.o mosquitto_db_dump

=== test/broker/Makefile ===
--- 
+++ 
@@ -20,6 +20,7 @@
 	./01-connect-invalid-id-0.py
 	./01-connect-invalid-id-0-311.py
 	./01-connect-invalid-id-missing.py
+	./01-connect-invalid-reserved.py
 	./01-connect-anon-denied.py
 	./01-connect-uname-no-password-denied.py
 	./01-connect-uname-password-denied.py
@@ -58,6 +59,7 @@
 	./04-retain-qos0-repeated.py
 	./04-retain-qos1-qos0.py
 	./04-retain-qos0-clear.py
+	./04-retain-upgrade-outgoing-qos.py
 
 05 :
 	./05-clean-session-qos1.py 
@@ -70,6 +72,8 @@
 	./06-bridge-b2br-disconnect-qos2.py
 	./06-bridge-fail-persist-resend-qos1.py
 	./06-bridge-fail-persist-resend-qos2.py
+	./06-bridge-b2br-remapping.py
+	./06-bridge-br2b-remapping.py
 
 07 :
 	./07-will-qos0.py
@@ -88,8 +92,10 @@
 	./08-ssl-connect-identity.py
 	./08-ssl-connect-no-identity.py
 	./08-ssl-bridge.py
+ifeq ($(WITH_TLS_PSK),yes)
 	./08-tls-psk-pub.py
 	./08-tls-psk-bridge.py
+endif
 endif
 
 09 :

=== test/lib/cpp/Makefile ===
.PHONY: all test 01 02 03 04 08 09 clean reallyclean

CFLAGS=-I../../../lib -I../../../lib/cpp -DDEBUG -Werror
LIBS=../../../lib/libmosquitto.so.1 ../../../lib/cpp/libmosquittopp.so.1

all : 01 02 03 04 08 09

01-con-discon-success.test : 01-con-discon-success.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

01-will-set.test : 01-will-set.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

01-unpwd-set.test : 01-unpwd-set.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

01-will-unpwd-set.test : 01-will-unpwd-set.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

01-no-clean-session.test : 01-no-clean-session.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

01-keepalive-pingreq.test : 01-keepalive-pingreq.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

02-subscribe-qos0.test : 02-subscribe-qos0.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

02-subscribe-qos1.test : 02-subscribe-qos1.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

02-subscribe-qos2.test : 02-subscribe-qos2.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

02-unsubscribe.test : 02-unsubscribe.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

03-publish-qos0.test : 03-publish-qos0.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

03-publish-qos0-no-payload.test : 03-publish-qos0-no-payload.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

03-publish-c2b-qos1-timeout.test : 03-publish-c2b-qos1-timeout.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

03-publish-c2b-qos1-disconnect.test : 03-publish-c2b-qos1-disconnect.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

03-publish-c2b-qos2.test : 03-publish-c2b-qos2.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

03-publish-c2b-qos2-disconnect.test : 03-publish-c2b-qos2-disconnect.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

03-publish-c2b-qos2-timeout.test : 03-publish-c2b-qos2-timeout.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

03-publish-b2c-qos1.test : 03-publish-b2c-qos1.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

03-publish-b2c-qos2.test : 03-publish-b2c-qos2.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

04-retain-qos0.test : 04-retain-qos0.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

08-ssl-connect-no-auth.test : 08-ssl-connect-no-auth.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

08-ssl-connect-cert-auth.test : 08-ssl-connect-cert-auth.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

08-ssl-connect-cert-auth-enc.test : 08-ssl-connect-cert-auth-enc.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

08-ssl-bad-cacert.test : 08-ssl-bad-cacert.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

08-ssl-fake-cacert.test : 08-ssl-fake-cacert.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

09-util-topic-matching.test : 09-util-topic-matching.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

09-util-topic-tokenise.test : 09-util-topic-tokenise.cpp
	$(CXX) $< -o $@ $(CFLAGS) $(LIBS)

01 : 01-con-discon-success.test 01-will-set.test 01-unpwd-set.test 01-will-unpwd-set.test 01-no-clean-session.test 01-keepalive-pingreq.test

02 : 02-subscribe-qos0.test 02-subscribe-qos1.test 02-subscribe-qos2.test 02-unsubscribe.test

03 : 03-publish-qos0.test 03-publish-qos0-no-payload.test 03-publish-c2b-qos1-timeout.test 03-publish-c2b-qos1-disconnect.test 03-publish-c2b-qos2.test 03-publish-c2b-qos2-timeout.test 03-publish-c2b-qos2-disconnect.test 03-publish-b2c-qos1.test 03-publish-b2c-qos2.test

04 : 04-retain-qos0.test

08 : 08-ssl-connect-no-auth.test 08-ssl-connect-cert-auth.test 08-ssl-connect-cert-auth-enc.test 08-ssl-bad-cacert.test 08-ssl-fake-cacert.test

09 : 09-util-topic-matching.test 09-util-topic-tokenise.test

reallyclean : clean
	-rm -f *.orig

clean :
	rm -f *.test

=== debian/changelog ===
mosquitto (1.4.15-2ubuntu0.18.04.3) bionic-security; urgency=medium

  * SECURITY UPDATE: DoS (client disconnect) via invalid UTF-8 strings
    - debian/patches/add-validate-utf8.patch: Add validate UTF-8
    - debian/patches/CVE-2017-7653.patch: Add UTF-8 tests, plus some validation
      fixes
    - CVE-2017-7653
  * SECURITY UPDATE: Memory leak in the Mosquitto Broker allows unauthenticated
    clients to send crafted CONNECT packets which could cause DoS
    - debian/patches/CVE-2017-7654.patch: Fix memory leak that could be caused
      by a malicious CONNECT packet
    - CVE-2017-7654

 -- Eduardo Barretto <eduardo.barretto@canonical.com>  Tue, 18 Jun 2019 11:42:22 -0300

mosquitto (1.4.15-2ubuntu0.18.04.2) bionic-security; urgency=medium

  * Fix regression in update for CVE-2018-12546.

 -- Roger A. Light <roger@atchoo.org>  Wed, 13 Feb 2019 00:27:01 +0000

mosquitto (1.4.15-2ubuntu0.18.04.1) bionic-security; urgency=medium

  * SECURITY UPDATE: If Mosquitto is configured to use a password file for
    authentication, any malformed data in the password file will be treated as
    valid. This typically means that the malformed data becomes a username and
    no password. If this occurs, clients can circumvent authentication and get
    access to the broker by using the malformed username. In particular, a blank
    line will be treated as a valid empty username. Other security measures are
    unaffected. Users who have only used the mosquitto_passwd utility to create
    and modify their password files are unaffected by this vulnerability.
    - debian/patches/mosquitto-1.4.x-cve-2018-12551.patch: this fix introduces
      more stringent parsing tests on the password file data.
    - CVE-2018-12551
  * SECURITY UPDATE: If an ACL file is empty, or has only blank lines or
    comments, then mosquitto treats the ACL file as not being defined, which
    means that no topic access is denied. Although denying access to all
    topics is not a useful configuration, this behaviour is unexpected and
    could lead to access being incorrectly granted in some circumstances.
    - debian/patches/mosquitto-1.4.x-cve-2018-12550.patch: this fix ensures
      that if an ACL file is defined but no rules are defined, then access will
      be denied.
    - CVE-2018-12550
  * SECURITY UPDATE: If a client publishes a retained message to a topic that
    they have access to, and then their access to that topic is revoked, the
    retained message will still be delivered to future subscribers. This
    behaviour may be undesirable in some applications, so a configuration
    option `check_retain_source` has been introduced to enforce checking of
    the retained message source on publish.
    - debian/patches/mosquitto-1.4.15-cve-2018-12546.patch: this patch stores
      the originator of the retained message, so security checking can be
      carried out before re-publishing. The complexity of the patch is due to
      the need to save this information across broker restarts.
    - CVE-2018-12546

 -- Roger A. Light <roger@atchoo.org>  Wed, 06 Feb 2019 17:03:31 +0000

mosquitto (1.4.15-2) unstable; urgency=low

  * Replace mentions of 'c_rehash' with 'openssl rehash'. (Closes: #895084).

 -- Roger A. Light <roger@atchoo.org>  Sat, 07 Apr 2018 11:16:43 +0100

mosquitto (1.4.15-1) unstable; urgency=high

  * SECURITY UPDATE: If a SIGHUP is sent to the broker when there are no more
    file descriptors, then opening the configuration file will fail and
    security settings will be set back to their default values.
    - debian/patches/mosquitto-1.4.10_cve-2017-7652.patch: When reloading
      configuration, do this into a separate config struct. If nothing fails,
      then copy the new config over the old config.
    - CVE-2017-7652
  * SECURITY UPDATE: Unauthenticated clients can cause excessive memory usage.
    This has the potential to lead to an OOM situation and the broker being
    killed by the system.
    - debian/patches/mosquitto-1.4.10_cve-2017-7652.patch: Limit the maximum
      size of CONNECT packet to a reasonable value, and add "memory_limit"
      option to set the maximum memory the broker will use.
    - CVE-2017-7651
  * New upstream release.
  * Remove upstart support, which had accidently been reinstated in 1.4.14-2.
  * Bumped standards version to 4.1.3, no changes required.
  * Fix global-files-wildcard-not-first-paragraph-in-dep5-copyright.

 -- Roger A. Light <roger@atchoo.org>  Wed, 28 Feb 2018 11:29:47 +0000

mosquitto (1.4.14-2) unstable; urgency=low

  * Fix lintian error "build-depends-on-obsolete-package"
  * Fix lintian warning "extended-description-line-too-long"
  * The 1.4.14 release relaxes the restrictions on client ids, which means
    that the mosquitto_pub/sub autogenerated ids are no longer a problem.
    (closes: #870165).

 -- Roger A. Light <roger@atchoo.org>  Tue, 26 Dec 2017 22:03:57 +0000

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: mosquitto
 Section: net
 Priority: optional
-Maintainer: Roger A. Light <roger@atchoo.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Roger A. Light <roger@atchoo.org>
 Build-Depends: debhelper (>= 10),
-               dh-systemd,
                libc-ares-dev,
                libssl-dev (>=1.0.0),
                libwebsockets-dev (>=2.0),
@@ -11,7 +11,7 @@
                python-all (>= 2.6.6-3~),
                uthash-dev,
                uuid-dev
-Standards-Version: 4.1.2
+Standards-Version: 4.1.3
 Homepage: http://mosquitto.org/
 Vcs-Git: https://github.com/eclipse/mosquitto
 Vcs-Browser: https://github.com/eclipse/mosquitto/tree/debian
@@ -73,8 +73,8 @@
 Breaks: libmosquitto0-dev (<< 1.2-1~)
 Description: MQTT version 3.1/3.1.1 client library, development files
  This is the header and man page for the libmosquitto1 C library, which is a
- library for implementing MQTT version 3.1/3.1.1 clients. This package is needed to do
- development with libmosquitto1.
+ library for implementing MQTT version 3.1/3.1.1 clients. This package is
+ needed to do development with libmosquitto1.
 
 Package: libmosquittopp1
 Section: libs
